import sqlite3, random

class RPP:
    
    @staticmethod
    def get_random_poem(poet = None, ghaleb = None) -> str:
        """
        A module which returns poems.
        Current (poets) available are: [Khayyam]\n
        Available genre (ghaleb) for each poet is:
        Khayyam: [Rubaii]
        """


        conn = sqlite3.connect("Random_Persian_Poem.sqlite")
        cur = conn.cursor()
        
        if ((poet == None) and (ghaleb == None)):
                cur.execute("SELECT poem FROM Poems")
                choices = cur.fetchall()
                num = len(choices)
                rand = random.randint(0, num-1)
                return choices[rand][0]
        
        elif ((poet != None) and (ghaleb == None)):
            if (type(poet) != str):
                try:
                    raise TypeError("Wrong argument type for (poet).")
                except:
                    raise
            cur.execute("SELECT id FROM Poets WHERE name=?", (poet,))
            id = cur.fetchone()
            if (id == None):
                try:
                    raise ValueError("Value of (poet) does not seem to be valid.")
                except:
                    raise
            id = id[0]
            cur.execute("SELECT poem FROM Poems WHERE poet_id=?", (id,))
            choices = cur.fetchall()
            num = len(choices)
            rand = random.randint(0, num-1)
            return choices[rand][0]
        
        elif ((poet == None) and (ghaleb != None)):
            if (type(ghaleb) != str):       
                try:
                    raise TypeError("Wrong argument type for (ghaleb).")
                except:
                    raise
            cur.execute("SELECT id FROM Ghaleb WHERE name=?", (ghaleb,))
            id = cur.fetchone()
            if (id == None):
                try:
                    raise ValueError("Value of (ghaleb) does not seem to be valid.")
                except:
                    raise
            id = id[0]
            cur.execute("SELECT poem FROM Poems WHERE ghaleb_id=?", (id,))
            choices = cur.fetchall()
            num = len(choices)
            rand = random.randint(0, num-1)
            return choices[rand][0]
        
        else:
            if (type(poet) != str):
                try:
                    raise TypeError("Wrong argument type for (poet).")
                except:
                    raise
            if (type(ghaleb) != str):
                try:
                    raise TypeError("Wrong argument type for (ghaleb).")
                except:
                    raise
            cur.execute("SELECT id FROM Ghaleb WHERE name=?", (ghaleb,))
            g_id = cur.fetchone()
            if (g_id == None):
                try:
                    raise ValueError("Value of (ghaleb) does not seem to be valid.")
                except:
                    raise
            g_id = g_id[0]
            cur.execute("SELECT id FROM Poets WHERE name=?", (poet,))
            p_id = cur.fetchone()
            if (p_id == None):
                try:
                    raise ValueError("Value of (poet) does not seem to be valid.")
                except:
                    raise
            p_id = p_id[0]
            cur.execute("SELECT poem FROM Poems WHERE ghaleb_id=? AND poet_id=?", (g_id, p_id))
            choices = cur.fetchall()
            num = len(choices)
            rand = random.randint(0, num-1)
            return choices[rand][0]